/*****************************************************
This program was produced by the
CodeWizardAVR V2.05.3 Standard
Automatic Program Generator
 Copyright 1998-2011 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 26.03.2013
Author  : 
Company : 
Comments: 


Chip type               : ATmega8
Program type            : Application
AVR Core Clock frequency: 8,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*****************************************************/

#include <mega8.h>
#include <delay.h>

// Declare your global variables here

void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=Out Func2=Out Func1=Out Func0=In 
// State7=T State6=T State5=T State4=T State3=0 State2=0 State1=0 State0=T 
PORTB=0x00;
DDRB=0x0E;

// Port C initialization
// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x00;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
TCCR0=0x00;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 1000,000 kHz
// Mode: Fast PWM top=0x00FF
// OC1A output: Inverted
// OC1B output: Inverted
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0xF1;
TCCR1B=0x0A;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: 1000,000 kHz
// Mode: Fast PWM top=0xFF
// OC2 output: Inverted PWM
ASSR=0x00;
TCCR2=0x7A;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;

// USART initialization
// USART disabled
UCSRB=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// ADC initialization
// ADC disabled
ADCSRA=0x00;

// SPI initialization
// SPI disabled
SPCR=0x00;

// TWI initialization
// TWI disabled
TWCR=0x00;

#define RED OCR1AL  //       .  OCR1BL++  .   ,   BLUE++   .   
#define GREEN OCR1BL //    .  OCR1BL++  .   ,   BLUE++   . 
#define BLUE OCR2     //    .  OCR1BL++  .   ,   BLUE++   .
#define DELAY 20     //      ,    DELAY.    . 

//  
while (1)
      {
      // Place your code here
static bit RED_ON=1, GREEN_ON=0, BLUE_ON=0 ; // "",    - 
// -         
//  "1",      . 
//()...


      if(RED_ON) //     ...
                {
                if(RED<255) //..         ( 8    255  ), ..
                             {
                             RED++; //..     .
                             if(BLUE>0) BLUE--; //   ,    
                             }
                             else //       (255), .. 
                             {
                             GREEN_ON=1; //   ..
                             RED_ON=0;   //   ,          

                             } 
                };
      if(GREEN_ON) //         .       ,
                   //    ,      .     ( ), 
                   //        .   .
                {
                if(GREEN<255){GREEN++; if(RED>0)RED--;} else {GREEN_ON=0;BLUE_ON=1;} 
                };


      if(BLUE_ON) //     ...
                {
                if(BLUE<255) //..         ( 8    255  ), ..
                            {
                            BLUE++; //..     . 
                            if(GREEN>0) GREEN--; //     ,   , 
                                                 //      (   
                                                 // ,   255   )
                                                 //    ,      . 
                            }
                            else  //       (255), .. 
                            {
                            RED_ON=1; //   .. 
                            BLUE_ON=0; //   ,           
                            } 

                };


      delay_ms(DELAY); // .  DELAY  ,   #define-. 

//      ,       ,      ))))
      }
}
